The Synthesis ToolKit in C++ (STK)

Home Information Classes Download Usage Mail List Requirements Links FAQ Tutorial

# stk::OnePole Class Reference

STK one-pole filter class. More...

`#include <OnePole.h>`

Inheritance diagram for stk::OnePole:

List of all members.

## Public Member Functions
| OnePole (StkFloat thePole=0.9)
| The default constructor creates a low-pass filter (pole at z = 0.9).
| ~OnePole ()
| Class destructor.
void | setB0 (StkFloat b0)
| Set the b[0] coefficient value.
void | setA1 (StkFloat a1)
| Set the a[1] coefficient value.
void | setCoefficients (StkFloat b0, StkFloat a1, bool clearState=false)
| Set all filter coefficients.
void | setPole (StkFloat thePole)
| Set the pole position in the z-plane.
StkFloat | lastOut (void) const
| Return the last computed output value.
StkFloat | tick (StkFloat input)
| Input one sample to the filter and return one output.
StkFrames & | tick (StkFrames &frames, unsigned int channel=0)
| Take a channel of the StkFrames object as inputs to the filter and replace with corresponding outputs.
StkFrames & | tick (StkFrames &iFrames, StkFrames &oFrames, unsigned int iChannel=0, unsigned int oChannel=0)
| Take a channel of the `iFrames` object as inputs to the filter and write outputs to the `oFrames` object.

## Detailed Description

STK one-pole filter class.

This class implements a one-pole digital filter. A method is provided for setting the pole position along the real axis of the z-plane while maintaining a constant peak filter gain.

by Perry R. Cook and Gary P. Scavone, 1995-2012.

## Member Function Documentation

void stk::OnePole::setPole | ( | StkFloat | thePole | ) |

Set the pole position in the z-plane.

This method sets the pole position along the real-axis of the z-plane and normalizes the coefficients for a maximum gain of one. A positive pole value produces a low-pass filter, while a negative pole value produces a high-pass filter. This method does not affect the filter gain value. The argument magnitude should be less than one to maintain filter stability.

StkFrames & stk::OnePole::tick | ( | StkFrames & | frames,
|  | unsigned int | channel = `0` |
| ) |  |  | `[inline, virtual]`

Take a channel of the StkFrames object as inputs to the filter and replace with corresponding outputs.

The StkFrames argument reference is returned. The `channel` argument must be less than the number of channels in the StkFrames argument (the first channel is specified by 0). However, range checking is only performed if _STK_DEBUG_ is defined during compilation, in which case an out-of-range value will trigger an StkError exception.

Implements stk::Filter.

    00090 {
    00091 #if defined(_STK_DEBUG_)
    00092   if ( channel >= frames.channels() ) {
    00093     oStream_ << "OnePole::tick(): channel and StkFrames arguments are incompatible!";
    00094     handleError( StkError::FUNCTION_ARGUMENT );
    00095   }
    00096 #endif
    00097
    00098   StkFloat *samples = &frames[channel];
    00099   unsigned int hop = frames.channels();
    00100   for ( unsigned int i=0; i<frames.frames(); i++, samples += hop ) {
    00101     inputs_[0] = gain_ * *samples;
    00102     *samples = b_[0] * inputs_[0] - a_[1] * outputs_[1];
    00103     outputs_[1] = *samples;
    00104   }
    00105
    00106   lastFrame_[0] = outputs_[1];
    00107   return frames;
    00108 }

StkFrames & stk::OnePole::tick | ( | StkFrames & | iFrames,
|  | StkFrames & | oFrames,
|  | unsigned int | iChannel = `0`,
|  | unsigned int | oChannel = `0` |
| ) |  |  | `[inline]`

Take a channel of the `iFrames` object as inputs to the filter and write outputs to the `oFrames` object.

The `iFrames` object reference is returned. Each channel argument must be less than the number of channels in the corresponding StkFrames argument (the first channel is specified by 0). However, range checking is only performed if _STK_DEBUG_ is defined during compilation, in which case an out-of-range value will trigger an StkError exception.

    00111 {
    00112 #if defined(_STK_DEBUG_)
    00113   if ( iChannel >= iFrames.channels() || oChannel >= oFrames.channels() ) {
    00114     oStream_ << "OnePole::tick(): channel and StkFrames arguments are incompatible!";
    00115     handleError( StkError::FUNCTION_ARGUMENT );
    00116   }
    00117 #endif
    00118
    00119   StkFloat *iSamples = &iFrames[iChannel];
    00120   StkFloat *oSamples = &oFrames[oChannel];
    00121   unsigned int iHop = iFrames.channels(), oHop = oFrames.channels();
    00122   for ( unsigned int i=0; i<iFrames.frames(); i++, iSamples += iHop, oSamples += oHop ) {
    00123     inputs_[0] = gain_ * *iSamples;
    00124     *oSamples = b_[0] * inputs_[0] - a_[1] * outputs_[1];
    00125     outputs_[1] = *oSamples;
    00126   }
    00127
    00128   lastFrame_[0] = outputs_[1];
    00129   return iFrames;
    00130 }

The documentation for this class was generated from the following file:

- OnePole.h

The Synthesis ToolKit in C++ (STK)
©1995-2012 Perry R. Cook and Gary P. Scavone. All Rights Reserved.